.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\gdi32.inc
INCLUDELIB \masm32\lib\gdi32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST

IDR_MAINMENU EQU   101
IDM_ASSEMBLE EQU 40001

.DATA

ClassName          DB "PipeWinClass", 0
AppName            DB "Potok Jednokierunkowy", 0
EditClass          DB "EDIT", 0
CreatePipeError    DB "Bd przy tworzeniu potoku", 0
CreateProcessError DB "Bd przy tworzeniu procesu", 0

;--------------------------------------------------------------
;UWAGA:
;Poniszy wiersz umoliwia wywoanie programu ml.exe. Jeli
;znajduje si on w innym katalogu ni podany poniej, to
;musisz odpowiednio zmodyfikowa polecenie. W przeciwnym
;razie prezentowany przykad nie uruchomi tego procesu
;--------------------------------------------------------------

CommandLine        DB "\masm32\bin\ml /c /coff /Cp test.asm", 0

.DATA?

hInstance HINSTANCE ?
hwndEdit  DD        ?

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax

WinMain PROC hInst:     DWORD,\
             hPrevInst: DWORD,\
             CmdLine:   DWORD,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_APPWORKSPACE
    mov    wc.lpszMenuName, IDR_MAINMENU
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPEDWINDOW OR WS_VISIBLE,\
                           CW_USEDEFAULT, CW_USEDEFAULT,\
                           467, 200, NULL, NULL, hInst, NULL
    mov    hwnd, eax

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL rect:         RECT
LOCAL hRead:        DWORD
LOCAL hWrite:       DWORD
LOCAL startupinfo:  STARTUPINFO
LOCAL pinfo:        PROCESS_INFORMATION
LOCAL buffer[1024]: BYTE
LOCAL bytesRead:    DWORD
LOCAL hdc:          DWORD
LOCAL sat:          SECURITY_ATTRIBUTES

    .IF uMsg==WM_CREATE
        INVOKE CreateWindowEx, NULL, ADDR EditClass, NULL,\
                               WS_CHILD OR WS_VISIBLE OR \
                               ES_MULTILINE OR ES_AUTOHSCROLL OR \
                               ES_AUTOVSCROLL, 0, 0, 0, 0,\
                               hWnd, NULL, hInstance, NULL
        mov    hwndEdit, eax
    .ELSEIF uMsg==WM_CTLCOLOREDIT
        INVOKE SetTextColor, wParam, Yellow
        INVOKE SetBkColor, wParam, Black
        INVOKE GetStockObject, BLACK_BRUSH
        ret
    .ELSEIF uMsg==WM_SIZE
        movzx  edx, WORD PTR lParam
        movzx  ecx, WORD PTR lParam + 2
        INVOKE MoveWindow, hwndEdit, 0, 0, edx, ecx, TRUE
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam==0
            mov eax, wParam
            .IF ax==IDM_ASSEMBLE
                mov    sat.nLength, SIZEOF SECURITY_ATTRIBUTES
                mov    sat.lpSecurityDescriptor, NULL
                mov    sat.bInheritHandle, TRUE
                INVOKE CreatePipe, ADDR hRead, ADDR hWrite,\
                                   ADDR sat, NULL
                .IF eax==NULL
                    INVOKE MessageBox, hWnd,\
                                       ADDR CreatePipeError, ADDR AppName,\
                                       MB_ICONERROR OR MB_OK
                .ELSE
                    mov    startupinfo.cb, SIZEOF STARTUPINFO
                    INVOKE GetStartupInfo, ADDR startupinfo
                    mov    eax, hWrite
                    mov    startupinfo.hStdOutput, eax
                    mov    startupinfo.hStdError, eax
                    mov    startupinfo.dwFlags, STARTF_USESHOWWINDOW OR \
                                                STARTF_USESTDHANDLES
                    mov    startupinfo.wShowWindow, SW_HIDE

;-------------------------------------------------
; Tworzenie procesu
;-------------------------------------------------

                    INVOKE CreateProcess, NULL, ADDR CommandLine,\
                                          NULL, NULL, TRUE, NULL, NULL,\
                                          NULL, ADDR startupinfo,\
                                          ADDR pinfo
                    .IF eax==NULL
                        INVOKE MessageBox, hWnd,\
                                           ADDR CreateProcessError,\
                                           ADDR AppName,\
                                           MB_ICONERROR OR MB_OK
                    .ELSE
                        INVOKE CloseHandle, hWrite
                        .WHILE TRUE
                            INVOKE RtlZeroMemory, ADDR buffer, 1024
                            INVOKE ReadFile, hRead, ADDR buffer, 1023,\
                                             ADDR bytesRead, NULL
                            .BREAK .IF (!eax)
                            INVOKE SendMessage, hwndEdit,\
                                                EM_SETSEL, -1, 0
                            INVOKE SendMessage, hwndEdit,\
                                                EM_REPLACESEL, FALSE,\
                                                ADDR buffer
                        .ENDW
                    .ENDIF
                    INVOKE CloseHandle, hRead
                    INVOKE CloseHandle, pinfo.hProcess
                    INVOKE CloseHandle, pinfo.hThread
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam		
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

END start
